'
'
'      __                     ______      _      _     _           ____
'    /    \  /  \  __  /  \ /        \  /   \  /   \ /   \       /      \
'   |  \   | |  |/    \|  | \ _    _ /  \   /  \   / |   |      |   ___ /
'    \   \_/ |  |  ||  |  |    |  |     |   |  |   | |   |      |     \
'    / \  \  |  |  ||  |  |   _|  |_     \   \/   /  |   \ __   |   __/
'   |   \  | |    /  \    | /        \    |      |   |        \ |       \
'    \___ /   \__/    \__/  \ ______ /     \ __ /     \ _____ /  \ ____ /
'                                                                 V  2.5
'                                      N
'                                           I
'                                    L
'                                              R
'                                          A
'                                                   C
'
'
'      =============================================================
'     |                                                             |
'     |                |
'     |                                                   |
'     |                                 |
'     |                                                    |
'     |                                    |
'     |                                                             |
'     |                                                             |
'      =============================================================
'
'     N O T E :
'
'               As far as I know you must run this in QuickBasic 4.5
'               for it Gives an "Out of memmory" error.  I guess you
'               can try it.  Your comp might have more memmory than
'               mine.
'
'      =============================================================
'      Controls :
'      =============================================================
'                                 |
'                                 |
'      Player 1 : (ARROW KEYS)    |          Player 2 :
'                                 |
'                  UP             |                  "W"
'                                 |
'           LEFT       RIGHT      |             "A"       "D"
'                                 |
'                 DOWN            |                  "S"
'                                 |
'      SHOOT = "/"                |          SHOOT = "1"
'                                 |
'      =============================================================
'
'       If you want obstacles or not:
'
'
'                      If obstacles are off, then just hit F1.
'                      If obstacles are on, then just hit  F1.
'
'                      Remember:  If obstacles are on, then in the
'                                 top right corner it will say "OBS ON"
'
'                                 If you turn obstacles on and off,
'                                 then you must wait until the
'                                 next round for it to take affect.
'
'      =============================================================
'
'       If you want to make
'       it so the bricks are
'       solid and you cant
'       shoot through them :
'
'                      If you can shoot through them then hit  F2.
'                      If you cant shoot through them then hit F2.
'
'                      Remember:  If you cant shoot through them, then
'                                 in the top right corner it will say
'                                 "SOLID"
'
'                                 If you make it solid or not then you
'                                 must wait for the next round for it to
'                                 take affect.
'
'      =============================================================
DECLARE SUB intro ()
DECLARE SUB board ()
DECLARE SUB pause ()
DECLARE SUB pyrmd (aa!, bb!, which!)
DECLARE SUB balls (aaa, bbb, crs)
DECLARE SUB bricks (a, B, col)
DECLARE SUB bigletter (word$, size!, clr!, style!, xpos!, ypos!)
DECLARE SUB bmp (file$, wht)
DECLARE SUB wavplay (file$, Frec&)
DECLARE FUNCTION SpeakerStatus% ()
DECLARE FUNCTION DMAStatus% ()
DECLARE FUNCTION DMADONE% ()
DECLARE FUNCTION ResetDSP% ()
DECLARE SUB FMVolume (right%, left%, Getvol%)
DECLARE SUB VocVolume (right%, left%, Getvol%)
DECLARE SUB MasterVolume (right%, left%, Getvol%)
DECLARE SUB MicVolume (Gain%, Getvol%)
DECLARE SUB LineVolume (right%, left%, Getvol%)
DECLARE SUB CDVolume (right%, left%, Getvol%)
DECLARE SUB InputSource (InputSrc%, GetSrc%)
DECLARE SUB WriteDSP (byte%)
DECLARE SUB SetStereo (OnOff%)
DECLARE FUNCTION ReadDSP% ()
DECLARE SUB WriteDAC (byte%)
DECLARE SUB SpeakerState (OnOff%)
DECLARE SUB DMAState (StopGo%)
DECLARE FUNCTION ReadDAC% ()
DECLARE SUB DMAPlay (Segment&, Offset&, Length&, Freq&)
DECLARE SUB DMARecord (Segment&, Offset&, Length&, Freq&)
DECLARE SUB GetBLASTER (DMA%, BasePort%, IRQ%)
DECLARE FUNCTION DSPVersion! ()
COMMON SHARED BasePort%, LenPort%, Channel%
CLEAR , , 28000
DIM pause1(2000)
m1clr = 12
m2clr = 73
m1name$ = "Nilrac"
m2name$ = "Sphen"
sld$ = "N"
slds$ = "N"
obs$ = "Y"
obss$ = "Y"
GetBLASTER Channel%, BasePort%, IRQ%
IF ResetDSP% THEN
PRINT "DSP reset sucessfully!"
ELSE
PRINT "DSP failed to reset, try another port."
END IF
SpeakerState 1
MasterVolume right%, left%, -1
MasterVolume 13, 13, 0
DIM SHARED WavBuffer(1 TO 1) AS STRING * 32767
CLS
intro
GOTO menu
playit:
m1x = 180
m1y = 120
m1dir = 4
m2x = 130
m2y = 120
m2dir = 3
CLS
board
IF obs$ = "Y" THEN GOSUB addobs
COLOR 7
LOCATE 1, 1: PRINT "                                        "
LOCATE 1, 1: PRINT " "; m1name$; " > "; m1scr
IF obs$ = "Y" THEN LOCATE 1, 30: PRINT "OBS ON"
LOCATE 2, 1: PRINT "                                        "
LOCATE 2, 1: PRINT " "; m2name$; " > "; m2scr
IF sld$ = "Y" THEN LOCATE 2, 30: PRINT "SOLID ON"
DO
GOSUB menmove
FOR la = 1 TO 4000: NEXT la
inky$ = INKEY$
SELECT CASE inky$
 CASE CHR$(0) + ";"
  IF obss$ = "Y" THEN obss$ = "N": LOCATE 1, 30: PRINT "(OBS OFF)": GOTO ignr
  IF obss$ = "N" THEN obss$ = "Y": LOCATE 1, 30: PRINT "(OBS ON) ": GOTO ignr
 CASE CHR$(0) + "<"
  IF slds$ = "Y" THEN slds$ = "N": LOCATE 2, 30: PRINT "(SOLID OFF)": GOTO ignr
  IF slds$ = "N" THEN slds$ = "Y": LOCATE 2, 30: PRINT "(SOLID ON) ": GOTO ignr
 CASE "p", "P": pause
 CASE CHR$(27): wavplay "mind.wav", 16000: GOTO menu
 CASE CHR$(0) + "H"
   IF m1dir = 2 THEN GOTO ignr
   m1dir = 1
 CASE CHR$(0) + "P"
   IF m1dir = 1 THEN GOTO ignr
   m1dir = 2
 CASE CHR$(0) + "K"
   IF m1dir = 4 THEN GOTO ignr
   m1dir = 3
 CASE CHR$(0) + "M"
   IF m1dir = 3 THEN GOTO ignr
   m1dir = 4
 CASE "/": GOSUB m1shoot
 CASE "W", "w"
   IF m2dir = 2 THEN GOTO ignr
   m2dir = 1
 CASE "S", "s"
   IF m2dir = 1 THEN GOTO ignr
   m2dir = 2
 CASE "A", "a"
   IF m2dir = 4 THEN GOTO ignr
   m2dir = 3
 CASE "D", "d"
   IF m2dir = 3 THEN GOTO ignr
   m2dir = 4
 CASE "1": GOSUB m2shoot
END SELECT
ignr:
PSET (m1x, m1y), m1clr
PSET (m2x, m2y), m2clr
LOOP




menmove:
IF m1dir = 1 THEN m1y = m1y - 1
IF m1dir = 2 THEN m1y = m1y + 1
IF m1dir = 3 THEN m1x = m1x - 1
IF m1dir = 4 THEN m1x = m1x + 1
'========
IF m2dir = 1 THEN m2y = m2y - 1
IF m2dir = 2 THEN m2y = m2y + 1
IF m2dir = 3 THEN m2x = m2x - 1
IF m2dir = 4 THEN m2x = m2x + 1

IF m1x = m2x AND m1y = m2y THEN GOTO tie
'==========
IF POINT(m1x, m1y) > 0 THEN GOTO m1dead
'=
IF POINT(m2x, m2y) > 0 THEN GOTO m2dead
RETURN

m1dead:
IF obss$ = "Y" THEN obs$ = "Y"
IF obss$ = "N" THEN obs$ = "N"
IF slds$ = "Y" THEN sld$ = "Y"
IF slds$ = "N" THEN sld$ = "N"
wavplay "die.wav", 11000
DO: LOOP UNTIL DMADONE
m2scr = m2scr + 1
LOCATE 1, 1: PRINT "                                        "
LOCATE 2, 1: PRINT "                                        "
LOCATE 1, 1
PRINT " "; m2name$; " is the winner!"
DO
FOR I = 1 TO 15000
NEXT I
c = c + 1
LOOP UNTIL c = 12
c = 0
LOCATE 1, 1: PRINT "                                        "
LOCATE 1, 1: PRINT " "; m1name$; " > "; m1scr
LOCATE 2, 1: PRINT "                                        "
LOCATE 2, 1: PRINT " "; m2name$; " > "; m2scr

GOTO again
m2dead:
IF obss$ = "Y" THEN obs$ = "Y"
IF obss$ = "N" THEN obs$ = "N"
IF slds$ = "Y" THEN sld$ = "Y"
IF slds$ = "N" THEN sld$ = "N"
wavplay "die.wav", 11000
DO: LOOP UNTIL DMADONE
m1scr = m1scr + 1
LOCATE 1, 1: PRINT "                                        "
LOCATE 2, 1: PRINT "                                        "
LOCATE 1, 1
PRINT " "; m1name$; " is the winner!"
DO
FOR I = 1 TO 15000
NEXT I
c = c + 1
LOOP UNTIL c = 12
c = 0
LOCATE 1, 1: PRINT "                                        "
LOCATE 1, 1: PRINT " "; m1name$; " > "; m1scr
LOCATE 2, 1: PRINT "                                        "
LOCATE 2, 1: PRINT " "; m2name$; " > "; m2scr
GOTO again

tie:
wavplay "tie.wav", 11000
PSET (m1x, m1y), m1clr
PSET (m2x, m2y), m2clr
LOCATE 1, 1: PRINT "                                        "
LOCATE 2, 1: PRINT "                                        "
LOCATE 1, 1: PRINT " T I E ! ! !"
DO
FOR I = 1 TO 15000
NEXT I
c = c + 1
LOOP UNTIL c = 12
c = 0
GOTO again

m1shoot:
wavplay "shoot.wav", 11000
m1bul1 = m1x
m1bul2 = m1y
DO
IF m1dir = 1 THEN m1bul2 = m1bul2 - 1
IF m1dir = 2 THEN m1bul2 = m1bul2 + 1
IF m1dir = 3 THEN m1bul1 = m1bul1 - 1
IF m1dir = 4 THEN m1bul1 = m1bul1 + 1
IF POINT(m1bul1, m1bul2) > 0 THEN GOSUB expld1: RETURN
LOOP
RETURN

m2shoot:
wavplay "shoot.wav", 11000
m2bul1 = m2x
m2bul2 = m2y
DO
IF m2dir = 1 THEN m2bul2 = m2bul2 - 1
IF m2dir = 2 THEN m2bul2 = m2bul2 + 1
IF m2dir = 3 THEN m2bul1 = m2bul1 - 1
IF m2dir = 4 THEN m2bul1 = m2bul1 + 1
IF POINT(m2bul1, m2bul2) > 0 THEN GOSUB expld2: RETURN
LOOP

expld1:
DO
CIRCLE (m1bul1, m1bul2), cont, m1clr
FOR I = 1 TO 2000: NEXT I
IF POINT(m1x, m1y) = m1clr THEN GOTO m1dead
IF POINT(m2x, m2y) = m1clr THEN GOTO m2dead
CIRCLE (m1bul1, m1bul2), cont, 0
cont = cont + 1
LOOP UNTIL cont = 15
cont = 0
board
IF sld$ = "Y" THEN GOSUB renewit
RETURN
expld2:
DO
CIRCLE (m2bul1, m2bul2), cont, m2clr
FOR I = 1 TO 2000: NEXT I
IF POINT(m1x, m1y) = m2clr THEN GOTO m1dead
IF POINT(m2x, m2y) = m2clr THEN GOTO m2dead
CIRCLE (m2bul1, m2bul2), cont, 0
cont = cont + 1
LOOP UNTIL cont = 15
cont = 0
board
IF sld$ = "Y" THEN GOSUB renewit
RETURN

again:
SLEEP 1
GOTO playit



chngclrs:
GET (109, 80)-(209, 120), pause1
LINE (109, 80)-(209, 120), 15, BF
LINE (109, 80)-(209, 120), 40, B
LINE (110, 81)-(208, 119), 41, B
CIRCLE (155, 107), 5, m1clr: PAINT (155, 105), m1clr, m1clr
bigletter " Player 1", 1, 1, 12, 113, 90
DO
FOR I = 1 TO 1000: NEXT I
ink$ = INKEY$
COLOR m1clr
SELECT CASE ink$
 CASE CHR$(0) + "K"
   m1clr = m1clr - 1
   IF m1clr < 1 THEN m1clr = 1
   CIRCLE (155, 107), 5, m1clr
   PAINT (155, 107), m1clr, m1clr
 CASE CHR$(0) + "M"
   m1clr = m1clr + 1
   IF m1clr > 175 THEN m1clr = 175
   CIRCLE (155, 107), 5, m1clr
   PAINT (155, 107), m1clr, m1clr
 CASE CHR$(13): GOTO selected
END SELECT
LOCATE 14, 22: PRINT m1clr
LOOP
selected:

CIRCLE (155, 107), 5, m2clr: PAINT (155, 105), m2clr, m2clr
bigletter " ", 1, 15, 12, 113, 90
bigletter " Player 2", 1, 1, 12, 113, 90
DO
FOR I = 1 TO 1000: NEXT I
ink$ = INKEY$
COLOR m2clr
SELECT CASE ink$
 CASE CHR$(0) + "K"
   m2clr = m2clr - 1
   IF m2clr < 1 THEN m2clr = 1
   CIRCLE (155, 107), 5, m2clr
   PAINT (155, 107), m2clr, m2clr
 CASE CHR$(0) + "M"
   m2clr = m2clr + 1
   IF m2clr > 175 THEN m2clr = 175
   CIRCLE (155, 107), 5, m2clr
   PAINT (155, 107), m2clr, m2clr
 CASE CHR$(13): GOTO selected2
END SELECT
LOCATE 14, 22: PRINT m2clr
LOOP
selected2:
COLOR 7
LINE (109, 80)-(209, 120), 0, BF
PUT (109, 80), pause1
GOTO menu
RETURN

menu:
CLS
COLOR 7
DEF SEG = &HA000
BLOAD "carlin2.dat", 0
men = 101
DO
FOR I = 1 TO 400: NEXT I
inks$ = INKEY$
SELECT CASE inks$
 
 CASE CHR$(0) + "H"
   wavplay "click.wav", 11000
   IF men = 101 THEN PAINT (114, 83 + 2), 83, 41
   IF men = 102 THEN PAINT (114, 93 + 2), 83, 41
   IF men = 103 THEN PAINT (114, 103 + 2), 83, 41
   IF men = 104 THEN PAINT (114, 113 + 2), 83, 41
   IF men = 105 THEN PAINT (114, 123 + 2), 83, 41
   IF men = 106 THEN PAINT (114, 133 + 2), 83, 41
   men = men - 1
   IF men = 100 THEN men = 106
 CASE CHR$(0) + "P"
   wavplay "click.wav", 11000
   IF men = 101 THEN PAINT (114, 83 + 2), 83, 41
   IF men = 102 THEN PAINT (114, 93 + 2), 83, 41
   IF men = 103 THEN PAINT (114, 103 + 2), 83, 41
   IF men = 104 THEN PAINT (114, 113 + 2), 83, 41
   IF men = 105 THEN PAINT (114, 123 + 2), 83, 41
   IF men = 106 THEN PAINT (114, 133 + 2), 83, 41
   men = men + 1
   IF men = 107 THEN men = 101
 CASE CHR$(13): GOTO slct
END SELECT
IF men = 101 THEN CIRCLE (114, 83 + 2), 2, 100: PAINT (114, 83 + 2), 100, 100
IF men = 102 THEN CIRCLE (114, 93 + 2), 2, 100: PAINT (114, 93 + 2), 100, 100
IF men = 103 THEN CIRCLE (114, 103 + 2), 2, 100: PAINT (114, 103 + 2), 100, 100
IF men = 104 THEN CIRCLE (114, 113 + 2), 2, 100: PAINT (114, 113 + 2), 100, 100
IF men = 105 THEN CIRCLE (114, 123 + 2), 2, 100: PAINT (114, 123 + 2), 100, 100
IF men = 106 THEN CIRCLE (114, 133 + 2), 2, 100: PAINT (114, 133 + 2), 100, 100
LOOP
slct:
IF men = 106 THEN wavplay "bah.wav", 11000: SYSTEM
wavplay "begin.wav", 11000
IF men = 101 THEN GOTO playit
IF men = 102 THEN GOTO chngclrs
IF men = 103 THEN GOTO chngnms
IF men = 104 THEN GOTO sndfx
IF men = 105 THEN GOTO credits
chngnms:
CLS

FOR I = 16 TO 100
LINE (1, I - 16)-(319, I - 16), I
NEXT I
I = 100
FOR ii = 85 TO 169
LINE (1, ii)-(319, ii), I
I = I - 1
NEXT ii




LOCATE 5, 1
COLOR 78
LINE INPUT " Player 1 > "; m1name$
LOCATE 8, 1
COLOR 58
LINE INPUT " Player 2 > "; m2name$
FOR I = 1 TO 15000: NEXT I
LOCATE 12
COLOR 48
PRINT " Reset the scores? [Y/N]"
DO
FOR I = 1 TO 400: NEXT I
inkss$ = INKEY$
SELECT CASE inkss$
 CASE "y", "Y"
   m1scr = 0
   m2scr = 0
   GOTO menu
 CASE "n", "N"
   GOTO menu
END SELECT
LOOP

compmove:
IF m2x < 30 THEN m2dir = 1: GOSUB m2dead
IF m2x > 260 THEN m2dir = 2: GOSUB m2dead
IF m2y < 40 THEN m2dir = 3: GOSUB m2dead
IF m2y > 180 THEN c3dir = 4: GOSUB m2dead
PSET (m2x, m2y), m2clr
IF m2dir = 1 THEN m2y = m2y - 1
IF m2dir = 2 THEN m2y = m2y + 1
IF m2dir = 3 THEN m2x = m2x - 1
IF m2dir = 4 THEN m2x = m2x + 1
RANDOMIZE TIMER
LET ice = INT((RND) * 200) + 1
IF m2dir = 1 THEN
  IF ice = 30 THEN m2dir = 3
  IF ice = 40 THEN m2dir = 4
  GOTO done
END IF
IF m2dir = 2 THEN
  IF ice = 30 THEN m2dir = 3
  IF ice = 40 THEN m2dir = 4
  GOTO done
END IF
IF m2dir = 3 THEN
  IF ice = 10 THEN m2dir = 1
  IF ice = 20 THEN m2dir = 2
  GOTO done
END IF
IF m2dir = 4 THEN
  IF ice = 10 THEN m2dir = 1
  IF ice = 20 THEN m2dir = 2
  GOTO done
END IF
done:
RETURN

upscore:
LOCATE 1, 1
PRINT "                                                     "
LOCATE 2, 2
PRINT "                                                     "
LOCATE 1, 1
LOCATE 1, 1: PRINT " "; m1name$; " > "; m1scr
LOCATE 2, 1: PRINT " "; m2name$; " > "; m2scr
RETURN

addobs:

RANDOMIZE TIMER
LET blocks = INT((RND) * 10) + 1

renewit:
IF blocks = 1 THEN
bricks 115, 90, 2: bricks 175, 90, 2: bricks 145, 110, 2: bricks 105, 125, 2
bricks 125, 140, 2: bricks 145, 140, 2: bricks 165, 140, 2: bricks 185, 125, 2
END IF
IF blocks = 2 THEN
bricks 75, 50, 1: bricks 95, 50, 1: bricks 115, 50, 1: bricks 135, 50, 1
bricks 155, 50, 1: bricks 175, 50, 1: bricks 195, 50, 1: bricks 215, 50, 1
bricks 75, 95, 1: bricks 95, 95, 1: bricks 115, 95, 1: bricks 135, 95, 1
bricks 155, 95, 1: bricks 175, 95, 1: bricks 195, 95, 1: bricks 215, 95, 1
bricks 75, 140, 1: bricks 95, 140, 1: bricks 115, 140, 1: bricks 135, 140, 1
bricks 155, 140, 1: bricks 175, 140, 1: bricks 195, 140, 1: bricks 215, 140, 1
bricks 145, 125, 1: bricks 145, 110, 1: bricks 145, 80, 1: bricks 145, 65, 1
END IF
IF blocks = 3 THEN
bricks 75, 50, 3: bricks 95, 50, 3: bricks 115, 50, 3: bricks 135, 50, 3
bricks 155, 50, 3: bricks 175, 50, 3: bricks 195, 50, 3: bricks 215, 50, 3
bricks 135, 95, 3: bricks 75, 140, 3: bricks 95, 140, 3: bricks 115, 140, 3
bricks 135, 140, 3: bricks 155, 140, 3: bricks 175, 140, 3: bricks 195, 140, 3
bricks 215, 140, 3: bricks 135, 125, 3: bricks 135, 110, 3: bricks 135, 80, 3
bricks 135, 65, 3: bricks 155, 125, 3: bricks 155, 110, 3: bricks 155, 80, 3
bricks 155, 65, 3: bricks 155, 95, 3: bricks 215, 65, 3: bricks 215, 80, 3
bricks 215, 95, 3: bricks 215, 125, 3: bricks 75, 65, 3: bricks 75, 80, 3
bricks 75, 95, 3: bricks 75, 125, 3
END IF
IF blocks = 4 THEN
bricks 75, 50, 5: bricks 95, 50, 5: bricks 115, 50, 5: bricks 135, 50, 5
bricks 155, 50, 5: bricks 175, 50, 5: bricks 195, 50, 5: bricks 215, 50, 5
bricks 135, 95, 5: bricks 75, 140, 5: bricks 95, 140, 5: bricks 115, 140, 5
bricks 135, 140, 5: bricks 155, 140, 5: bricks 175, 140, 5: bricks 195, 140, 5
bricks 215, 140, 5: bricks 135, 125, 5: bricks 135, 110, 5: bricks 135, 80, 5
bricks 135, 65, 5: bricks 155, 125, 5: bricks 155, 110, 5: bricks 155, 80, 5
bricks 155, 65, 5: bricks 155, 95, 5: bricks 215, 65, 5: bricks 215, 80, 5
bricks 215, 95, 5: bricks 215, 125, 5: bricks 75, 65, 5: bricks 75, 80, 5
bricks 75, 95, 5: bricks 75, 125, 5: bricks 175, 65, 5: bricks 175, 80, 5
bricks 195, 65, 5: bricks 195, 80, 5: bricks 95, 65, 5: bricks 95, 80, 5
bricks 115, 65, 5: bricks 115, 80, 5
END IF
IF blocks = 5 THEN
bricks 75, 45, 4: bricks 115, 45, 4: bricks 155, 45, 4: bricks 195, 45, 4
bricks 235, 45, 4: bricks 55, 60, 4: bricks 95, 60, 4: bricks 135, 60, 4
bricks 175, 60, 4: bricks 215, 60, 4: bricks 75, 75, 4: bricks 115, 75, 4
bricks 155, 75, 4: bricks 195, 75, 4: bricks 235, 75, 4: bricks 55, 90, 4
bricks 95, 90, 4: bricks 135, 90, 4: bricks 175, 90, 4: bricks 215, 90, 4
bricks 75, 135, 4: bricks 115, 135, 4: bricks 155, 135, 4: bricks 195, 135, 4
bricks 235, 135, 4: bricks 55, 150, 4: bricks 95, 150, 4: bricks 135, 150, 4
bricks 175, 150, 4: bricks 215, 150, 4: bricks 55, 120, 4: bricks 235, 105, 4
END IF
IF blocks = 6 THEN
bricks 135, 115, 4: bricks 155, 115, 4: bricks 145, 85, 4: pyrmd 145, 70, 3
bricks 145, 55, 4: pyrmd 125, 55, 3: pyrmd 165, 55, 3: pyrmd 105, 100, 3
bricks 125, 100, 4: pyrmd 145, 100, 3: bricks 165, 100, 4: pyrmd 185, 100, 3
pyrmd 105, 125, 3: bricks 125, 125, 4: pyrmd 145, 125, 3: bricks 165, 125, 4
pyrmd 185, 125, 3
END IF
IF blocks = 7 THEN
pyrmd 145, 113, 7: pyrmd 145, 85, 7: pyrmd 145, 70, 7: pyrmd 145, 140, 7
pyrmd 145, 155, 7: pyrmd 85, 100, 7: pyrmd 105, 100, 7: pyrmd 125, 100, 7
pyrmd 145, 100, 7: pyrmd 165, 100, 7: pyrmd 185, 100, 7: pyrmd 205, 100, 7
pyrmd 225, 100, 7: pyrmd 245, 100, 7: pyrmd 245, 115, 7: pyrmd 45, 110, 7
pyrmd 45, 125, 7: pyrmd 65, 125, 7: pyrmd 85, 125, 7: pyrmd 105, 125, 7
pyrmd 125, 125, 7: pyrmd 145, 125, 7: pyrmd 165, 125, 7: pyrmd 185, 125, 7
pyrmd 205, 125, 7
END IF
IF blocks = 8 THEN
balls 95, 105, 1: balls 115, 105, 2: balls 135, 105, 1: balls 155, 105, 2
balls 175, 105, 1: balls 195, 105, 2: balls 215, 105, 1: balls 230, 145, 1
balls 80, 145, 1: balls 95, 135, 2: balls 115, 135, 1: balls 135, 135, 2
balls 155, 135, 1: balls 175, 135, 2: balls 195, 135, 1: balls 215, 135, 2
balls 155, 152, 2: balls 155, 169, 1: balls 155, 88, 1: balls 155, 71, 2
balls 135, 71, 1: balls 175, 71, 1
END IF
IF blocks = 9 THEN
balls 105, 100, 6: balls 125, 100, 8: balls 145, 100, 6: balls 165, 100, 8
balls 185, 100, 6: balls 205, 100, 8: balls 155, 115, 4: balls 165, 130, 7
balls 175, 145, 4: balls 145, 130, 7: balls 135, 145, 4
END IF
IF blocks = 10 THEN
balls 270, 110, 10: balls 175, 160, 9: balls 125, 140, 8: balls 155, 110, 7
balls 260, 150, 6: balls 100, 100, 5: balls 60, 70, 4: balls 150, 60, 3
balls 220, 75, 2: balls 60, 140, 1
END IF
RETURN
sndfx:
CLS
DEF SEG = &HA000
BLOAD "carlin3.dat", 0
numm = 1
LOCATE 13, 23
PRINT "    "
LOCATE 13, 23
PRINT numm
LOCATE 23
PRINT "Death & Decay"


DO
FOR I = 1 TO 1000: NEXT I
ink$ = INKEY$
SELECT CASE ink$
 CASE CHR$(0) + "P"
  numm = numm + 1
  IF numm = 12 THEN numm = 1
  LOCATE 13, 23
  PRINT "    "
  LOCATE 13, 23
  PRINT numm
  LOCATE 23: PRINT "                           "
  LOCATE 23
  IF numm = 1 THEN PRINT "Death & Decay"
  IF numm = 2 THEN PRINT "Opening Song"
  IF numm = 3 THEN PRINT "Pause Game"
  IF numm = 4 THEN PRINT "Make up your mind!!"
  IF numm = 5 THEN PRINT "Player Dead"
  IF numm = 6 THEN PRINT "Players Tie"
  IF numm = 7 THEN PRINT "Shoot"
  IF numm = 8 THEN PRINT "Menu Click"
  IF numm = 9 THEN PRINT "Menu select"
  IF numm = 10 THEN PRINT "Bah, to hell with this!!!"
  IF numm = 11 THEN PRINT "EXIT (NOT A SOUND)"
 CASE CHR$(0) + "H"
  numm = numm - 1
  IF numm = 0 THEN numm = 11
  LOCATE 13, 23
  PRINT "    "
  LOCATE 13, 23
  PRINT numm
  LOCATE 23: PRINT "                           "
  LOCATE 23
  IF numm = 1 THEN PRINT "Death & Decay"
  IF numm = 2 THEN PRINT "Opening Song"
  IF numm = 3 THEN PRINT "Pause Game"
  IF numm = 4 THEN PRINT "Make up your mind!!"
  IF numm = 5 THEN PRINT "Player Dead"
  IF numm = 6 THEN PRINT "Players Tie"
  IF numm = 7 THEN PRINT "Shoot"
  IF numm = 8 THEN PRINT "Menu Click"
  IF numm = 9 THEN PRINT "Menu select"
  IF numm = 10 THEN PRINT "Bah, to hell with this!!!"
  IF numm = 11 THEN PRINT "EXIT (NOT A SOUND)"
 CASE CHR$(13): GOSUB slcts
END SELECT
LOOP
slcts:

SELECT CASE numm
 CASE 1: wavplay "intro.wav", 11000
 CASE 2: wavplay "opnsng.wav", 7000
 CASE 3: wavplay "pause.wav", 11000
 CASE 4: wavplay "mind.wav", 16000
 CASE 5: wavplay "die.wav", 11000
 CASE 6: wavplay "tie.wav", 11000
 CASE 7: wavplay "shoot.wav", 11000
 CASE 8: wavplay "click.wav", 11000
 CASE 9: wavplay "begin.wav", 11000
 CASE 10: wavplay "bah.wav", 11000
 CASE 11: GOTO menu
END SELECT
RETURN

credits:
DEF SEG = &HA000
BLOAD "credits.dat", 0
DO: LOOP WHILE INKEY$ = ""
GOTO menu

SUB balls (aaa, bbb, crs)

IF crs = 1 THEN col1 = 18
IF crs = 2 THEN col1 = 25
IF crs = 3 THEN col1 = 35
IF crs = 4 THEN col1 = 50
IF crs = 5 THEN col1 = 55
IF crs = 6 THEN col1 = 70
IF crs = 7 THEN col1 = 75
IF crs = 8 THEN col1 = 96
IF crs = 9 THEN col1 = 105
IF crs = 10 THEN col1 = 110

col2 = col1 + 1
col3 = col2 + 1
col4 = col3 + 1
col5 = col4 + 1
col6 = col5 + 1
col7 = col6 + 1
CIRCLE (aaa, bbb), 10, col1
PAINT (aaa, bbb), col1, col1
CIRCLE (aaa, bbb), 9, col2
PAINT (aaa, bbb), col2, col2
CIRCLE (aaa, bbb), 8, col3
PAINT (aaa, bbb), col3, col3
CIRCLE (aaa, bbb), 7, col4
PAINT (aaa, bbb), col4, col4
CIRCLE (aaa, bbb), 6, col5
PAINT (aaa, bbb), col5, col5
CIRCLE (aaa, bbb), 5, col6
PAINT (aaa, bbb), col6, col6
CIRCLE (aaa, bbb), 4, col7
PAINT (aaa, bbb), col7, col7

END SUB

SUB bigletter (word$, size, clr, style, xpos, ypos)
'word$,size,clr,style,xpos,ypos
DIM box(-1 TO 7, -1 TO 15)
    wordlength = LEN(word$) * size * 8
    wordheigth = size * 16
    wordcenter = xpos - (wordlenght / 2)
    PALETTE 15, 0
    FOR letter = 1 TO LEN(word$)
      LOCATE 1, 1
      PRINT MID$(word$, letter, 1)
      FOR x = 0 TO 7
        FOR y = 0 TO 15
         box(x, y) = POINT(x, y)
        NEXT y
      NEXT x
      IF style = 19 THEN PALETTE 0, 4
      FOR x = 0 TO 7
        right = left + size
        left = wordcenter + (x * size)
        lr = (left + right) \ 2
        FOR y = 0 TO 15
          up = ypos + (y * size)
          down = up + size
          ud = (up + down) \ 2
          IF box(x, y) THEN
            SELECT CASE style
               CASE 1
                 'solid
                 LINE (left, up)-(right, down), clr, BF
               CASE 2
                 'squars
                 LINE (left, up)-(right, down), clr, B
               CASE 3
                 'slant (\)
                 LINE (left, up)-(right, down), clr
               CASE 4
                 'slant (/)
                 LINE (right, up)-(left, down), clr
               CASE 5
                 'vertical lines
                 LINE (lr, up)-(right, ud), clr
               CASE 6
                 'horizontal lines
                 LINE (left, ud)-(right, ud), clr
               CASE 7
                 'crosses
                 LINE (lr, up)-(lr, down), clr
                 LINE (left, ud)-(right, ud), clr
               CASE 8
                 ' X's
                 LINE (left, up)-(right, down), clr
                 LINE (right, up)-(left, down), clr
               CASE 9
                 'ouline
                 IF box(x - 1, y) = 0 THEN LINE (left, up)-(left, down), clr
                 IF box(x + 1, y) = 0 THEN LINE (right, up)-(right, down), clr
                 IF box(x, y - 1) = 0 THEN LINE (left, up)-(right, up), clr
                 IF box(x, y + 1) = 0 THEN LINE (left, down)-(right, down), clr
               CASE 10
                 'spider web
                 IF box(x - 1, y) = 0 THEN LINE (lr, ud)-(left, ud), clr
                 IF box(x + 1, y) = 0 THEN LINE (lr, ud)-(right, ud), clr
                 IF box(x, y - 1) = 0 THEN LINE (lr, ud)-(lr, up), clr
                 IF box(x, y + 1) = 0 THEN LINE (lr, ud)-(lr, down), clr
                 IF box(x - 1, y - 1) = 0 THEN LINE (lr, ud)-(left, up), clr
                 IF box(x + 1, y - 1) = 0 THEN LINE (lr, ud)-(right, up), clr
                 IF box(x - 1, y + 1) = 0 THEN LINE (lr, ud)-(left, down), clr
                 IF box(x + 1, y + 1) = 0 THEN LINE (lr, ud)-(right, down), clr
               CASE 11
                 'bubbles
                 CIRCLE (lr, ud), size \ 2, clr
               CASE 12
                 'circles
                 CIRCLE (lr, ud), size \ 2, clr
                 PAINT STEP(0, 0), clr
               CASE 13
                 'shadow
                 IF box(x + 1, y) = 0 THEN LINE (right, up)-(right, down), clr
                 IF box(x, y + 1) = 0 THEN LINE (left, down)-(right, down), clr
                 IF box(x + 1, y + 1) = 0 THEN PSET (right, down), clr
               CASE 14
                 'seperated squares
                 LINE (left + 1, up + 1)-(right - 1, down - 1), clr, BF
               CASE 15
                 'building
                 LINE (left, down)-(lr, up), clr
                 LINE STEP(0, 0)-(right, down), clr
                 LINE STEP(0, 0)-(left, down), clr
                 LINE (left, up)-(right, up), clr
               CASE 16
                 'stars
                 LINE (lr, up)-(lr, down), clr
                 LINE (left, ud)-(right, ud), clr
                 LINE (left, up)-(right, down), clr
                 LINE (right, up)-(left, down), clr
               CASE 17
                'stuff
                LINE (lr, up)-(lr, down), clr + 1
                LINE (left, ud)-(right, ud), clr - 1
                LINE (left, up)-(right, down), clr + 2
                LINE (right, up)-(left, down), clr
          
                CASE 18
                 'spider web   different colors
                 IF box(x - 1, y) = 0 THEN LINE (lr, ud)-(left, ud), clr + 1
                 IF box(x + 1, y) = 0 THEN LINE (lr, ud)-(right, ud), clr - 1
                 IF box(x, y - 1) = 0 THEN LINE (lr, ud)-(lr, up), clr + 2
                 IF box(x, y + 1) = 0 THEN LINE (lr, ud)-(lr, down), clr - 2
                 IF box(x - 1, y - 1) = 0 THEN LINE (lr, ud)-(left, up), clr + 3
                 IF box(x + 1, y - 1) = 0 THEN LINE (lr, ud)-(right, up), clr - 3
                 IF box(x - 1, y + 1) = 0 THEN LINE (lr, ud)-(left, down), clr + 4
                 IF box(x + 1, y + 1) = 0 THEN LINE (lr, ud)-(right, down), clr
         
                CASE 19
                 'spider web   different colors
                 IF box(x - 1, y) = 0 THEN LINE (lr, ud)-(left, ud), clr + 1
                 IF box(x + 1, y) = 0 THEN LINE (lr, ud)-(right, ud), clr - 1
                 IF box(x, y - 1) = 0 THEN LINE (lr, ud)-(lr, up), clr + 2
                 IF box(x, y + 1) = 0 THEN LINE (lr, ud)-(lr, down), clr - 2
                 IF box(x - 1, y - 1) = 0 THEN LINE (lr, ud)-(left, up), clr + 3
                 IF box(x + 1, y - 1) = 0 THEN LINE (lr, ud)-(right, up), clr - 3
                 IF box(x - 1, y + 1) = 0 THEN LINE (lr, ud)-(left, down), clr + 4
                 IF box(x + 1, y + 1) = 0 THEN LINE (lr, ud)-(right, down), clr


               END SELECT
            END IF
           NEXT y
        NEXT x
        wordcenter = wordcenter + (size * 8)
        NEXT letter
        LOCATE 1, 1
        PRINT ""
        PALETTE
LOCATE 1, 1
PRINT " "
END SUB

SUB bmp (file$, wht)
CLS
DIM byte AS STRING * 1
OPEN file$ FOR BINARY AS #1
IF LOF(1) = 0 THEN PRINT "File not found!", 2: CLOSE : KILL file$: SYSTEM
table$ = INPUT$(54, #1)  'Get the file header (54 bytes)
DIM table&(30)           'Create numerical array for header
DEF SEG = VARSEG(table&(1))
pointer% = VARPTR(table&(1))
'Poke the data from string "table$" into numerical array "table&"
FOR x% = 0 TO 51
 POKE pointer% + x%, ASC(MID$(table$, x% + 3, 1))
NEXT
DEF SEG
'Check for valid file type
IF MID$(table$, 1, 2) <> "BM" OR table&(4) <> 40 THEN
   PRINT "Not a valid *.BMP file!": SYSTEM
END IF
'IF table&(8) <> 0 THEN
'   PRINT "This program will not diplay RLE encoded files": system
'END IF
'IF ASC(MID$(table$, 29, 1)) <> 4 THEN
'   PRINT "Only 16 color bitmaps are supported!": system
'END IF
'Set the video mode for best picture fit
IF (table&(5) < 321) AND (table&(6) < 201) THEN
   SCREEN 13
ELSE
   SCREEN 12
END IF
LOCATE 2, 1
thecolors$ = INPUT$(table&(3) - 54, #1) 'Read in pallette info
DEF SEG = VARSEG(pal&)
pointer% = VARPTR(pal&)
'Poke the pallette info from the string "thecolors$"
'into pal& and reduce to 6 bits per byte.
FOR x% = 0 TO 63 STEP 4
 POKE pointer%, (ASC(MID$(thecolors$, x% + 3, 1))) \ 4
 POKE pointer% + 1, (ASC(MID$(thecolors$, x% + 2, 1))) \ 4
 POKE pointer% + 2, (ASC(MID$(thecolors$, x% + 1, 1))) \ 4
 POKE pointer% + 3, 0
PALETTE x% \ 4, pal&
NEXT
DEF SEG
'Read in Bitmap data and set pixels accordingly
y% = table&(6) 'Put number of vertical pixels into y%
IF wht = 1 THEN SCREEN 13
DO
  file$ = INPUT$((((table&(5) - 1) OR 7) + 1) \ 2, #1)
    IF (table&(5) \ 2) < LEN(file$) THEN
       linelength% = table&(5) \ 2
    ELSE
       linelength% = LEN(file$)
    END IF
    FOR x% = 1 TO linelength%
      pixel% = ASC(MID$(file$, x%, 1))
      PSET (x% * 2 + 1, y%), pixel% AND 15
      PSET (x% * 2, y%), pixel% \ 16
     NEXT
    y% = y% - 1
LOOP UNTIL y% < 0
CLOSE #1


END SUB

SUB board
zz = 1
ss = 17
tt = 319
dd = 199
col = 20
DO
LINE (zz, ss)-(tt, dd), col, B
zz = zz + 1
ss = ss + 1
tt = tt - 1
dd = dd - 1
col = col + 1.5
LOOP UNTIL col > 31
LINE (zz, ss)-(tt, dd), 15, B
END SUB

SUB bricks (a, B, col)
'=======================================================================
'COL = (1 or 2 or 3 or 4 or 5)
'1 = gray
'2 = red
'3 = pink
'4 = purple
'5 = blue
'=======================================================================

IF col = 1 THEN
 rim = 20
 insd = 26
 shad = 23
END IF
IF col = 2 THEN
 rim = 182
 insd = 4
 shad = 39
END IF
IF col = 3 THEN
 rim = 84
 insd = 88
 shad = 86
END IF
IF col = 4 THEN
 rim = 58
 insd = 13
 shad = 60
END IF
IF col = 5 THEN
 rim = 55
 insd = 52
 shad = 53
END IF




LINE (a, B)-(a + 20, B + 15), rim, B
'PAINT (a + 1, b + 1), insd, rim
'PAINT (a + 19, b + 14), insd, rim
'PAINT (a + 19, b), insd, rim
'PAINT (a + 1, b + 14), insd, rim
LINE (a + 1, B + 1)-(a + 19, B + 14), insd, BF
PSET (a, B), 0: PSET (a, B + 15), 0
PSET (a + 20, B), 0: PSET (a + 20, B + 15), 0
LINE (a, B + 5)-(a + 20, B + 5), rim
LINE (a, B + 10)-(a + 20, B + 10), rim
LINE (a + 10, B)-(a + 10, B + 5), rim
LINE (a + 10, B + 10)-(a + 10, B + 15), rim
LINE (a + 5, B + 5)-(a + 5, B + 10), rim
LINE (a + 15, B + 5)-(a + 15, B + 10), rim
LINE (a, B + 6)-(a, B + 9), insd
LINE (a + 1, B + 1)-(a + 1, B + 4), shad
LINE (a + 11, B + 1)-(a + 11, B + 4), shad
LINE (a + 6, B + 6)-(a + 6, B + 9), shad
LINE (a + 16, B + 6)-(a + 16, B + 9), shad
LINE (a + 11, B + 11)-(a + 11, B + 14), shad
LINE (a + 1, B + 11)-(a + 1, B + 14), shad
END SUB

SUB CDVolume (right%, left%, Getvol%)
OUT BasePort% + 4, &H28
IF Getvol% THEN
   left% = INP(BasePort% + 5) \ 16
   right% = INP(BasePort% + 5) AND &HF
   EXIT SUB
ELSE
   OUT BasePort% + 5, (right% + left% * 16) AND &HFF
END IF
END SUB

FUNCTION DMADONE%
Count% = INP(LenPort%)
Count2% = INP(LenPort%)
Count& = CLNG(Count% + 1) * CLNG(Count2% + 1)
IF (Count& - 1) >= &HFFFF& THEN junk% = INP(DSPDataAvail%): DMADONE% = -1
END FUNCTION

SUB DMAPlay (Segment&, Offset&, Length&, Freq&)
' Transfers and plays the contents of the buffer.
Length& = Length& - 1
Page% = 0
MemLoc& = Segment& * 16 + Offset&
SELECT CASE Channel%
    CASE 0
       PgPort% = &H87
       AddPort% = &H0
       LenPort% = &H1
       ModeReg% = &H48
    CASE 1
       PgPort% = &H83
       AddPort% = &H2
       LenPort% = &H3
       ModeReg% = &H49
    CASE 2
       PgPort% = &H81
       AddPort% = &H4
       LenPort% = &H5
       ModeReg% = &H4A
    CASE 3
       PgPort% = &H82
       AddPort% = &H6
       LenPort% = &H7
       ModeReg% = &H4B
    CASE ELSE
       PRINT "DMA channels 0-3 only are supported."
       EXIT SUB
END SELECT

OUT &HA, &H4 + Channel%
OUT &HC, &H0
OUT &HB, ModeReg%
OUT AddPort%, MemLoc& AND &HFF
OUT AddPort%, (MemLoc& AND &HFFFF&) \ &H100
IF (MemLoc& AND 65536) THEN Page% = Page% + 1
IF (MemLoc& AND 131072) THEN Page% = Page% + 2
IF (MemLoc& AND 262144) THEN Page% = Page% + 4
IF (MemLoc& AND 524288) THEN Page% = Page% + 8
OUT PgPort%, Page%
OUT LenPort%, Length& AND &HFF
OUT LenPort%, (Length& AND &HFFFF&) \ &H100
OUT &HA, Channel%

IF Freq& < 23000 THEN
   TimeConst% = 256 - 1000000 \ Freq&
   WriteDSP &H40
   WriteDSP TimeConst%
   WriteDSP &H14
   WriteDSP (Length& AND &HFF)
   WriteDSP ((Length& AND &HFFFF&) \ &H100)
ELSE
   IF DSPVersion! >= 3 THEN
      TimeConst% = ((65536 - 256000000 \ Freq&) AND &HFFFF&) \ &H100
      WriteDSP &H40
      WriteDSP TimeConst%
      WriteDSP (Length& AND &HFF)
      WriteDSP ((Length& AND &HFFFF&) \ &H100)
      WriteDSP &H91
   ELSE
      PRINT "You need a Sound Blaster with a DSP v3.x+ to play at high speed."
      EXIT SUB
   END IF
END IF
END SUB

SUB DMARecord (Segment&, Offset&, Length&, Freq&)
Length& = Length& - 1
MemLoc& = Segment& * 16 + Offset&
Page% = 0
SELECT CASE Channel%
    CASE 0
       PgPort% = &H87
       AddPort% = &H0
       LenPort% = &H1
       ModeReg% = &H44
    CASE 1
       PgPort% = &H83
       AddPort% = &H2
       LenPort% = &H3
       ModeReg% = &H45
    CASE 2
       PgPort% = &H81
       AddPort% = &H4
       LenPort% = &H5
       ModeReg% = &H46
    CASE 3
       PgPort% = &H82
       AddPort% = &H6
       LenPort% = &H7
       ModeReg% = &H47
    CASE ELSE
       EXIT SUB
END SELECT

OUT &HA, &H4 + Channel%
OUT &HC, &H0
OUT &HB, ModeReg%
OUT AddPort%, MemLoc& AND &HFF
OUT AddPort%, (MemLoc& AND &HFFFF&) \ &H100
IF (LongByte& AND 65536) THEN Page% = Page% + 1
IF (LongByte& AND 131072) THEN Page% = Page% + 2
IF (LongByte& AND 262144) THEN Page% = Page% + 4
IF (LongByte& AND 524288) THEN Page% = Page% + 8
OUT PgPort%, Page%
OUT LenPort%, Length& AND &HFF
OUT LenPort%, (Length& AND &HFFFF&) \ &H100
OUT &HA, Channel%

IF Freq& <= 23000 THEN
   TimeConst% = 256 - 1000000 \ Freq&
   WriteDSP &H40
   WriteDSP TimeConst%
   WriteDSP &H24
   WriteDSP (Length& AND &HFF)
   WriteDSP ((Length& AND &HFFFF&) \ &H100)
ELSE
   IF DSPVersion! >= 3 THEN
      TimeConst% = ((65536 - 256000000 / Freq&) AND &HFFFF&) \ &H100
      WriteDSP &H40
      WriteDSP TimeConst%
      WriteDSP (Length& AND &HFF)
      WriteDSP ((Length& AND &HFFFF&) \ &H100)
      WriteDSP &H99
   ELSE
      PRINT "You need a Sound Blaster with a DSP 3.x+ to record at high speed."
      EXIT SUB
   END IF
END IF

END SUB

SUB DMAState (StopGo%)
' Stops or continues DMA play.
IF StopGo% THEN WriteDSP &HD4 ELSE WriteDSP &HD0

END SUB

FUNCTION DSPVersion!
' Gets the DSP version.
WriteDSP &HE1
Temp% = ReadDSP%
Temp2% = ReadDSP%
DSPVersion! = VAL(STR$(Temp%) + "." + STR$(Temp2%))
END FUNCTION

SUB FMVolume (right%, left%, Getvol%)
OUT BasePort% + 4, &H26
IF Getvol% THEN
   left% = INP(BasePort% + 5) \ 16
   right% = INP(BasePort% + 5) AND &HF
   EXIT SUB
ELSE
   OUT BasePort% + 5, (right% + left% * 16) AND &HFF
END IF
END SUB

SUB GetBLASTER (DMA%, BasePort%, IRQ%)
' This subroutine parses the BLASTER environment string and returns settings.
IF LEN(ENVIRON$("BLASTER")) = 0 THEN PRINT "BLASTER environment variable not set.": EXIT SUB
FOR Length% = 1 TO LEN(ENVIRON$("BLASTER"))
   SELECT CASE MID$(ENVIRON$("BLASTER"), Length%, 1)
      CASE "A"
        BasePort% = VAL("&H" + MID$(ENVIRON$("BLASTER"), Length% + 1, 3))
      CASE "I"
        IRQ% = VAL(MID$(ENVIRON$("BLASTER"), Length% + 1, 1))
      CASE "D"
        DMA% = VAL(MID$(ENVIRON$("BLASTER"), Length% + 1, 1))
   END SELECT
NEXT

END SUB

SUB InputSource (InputSrc%, GetSrc%)
OUT BasePort% + 4, &HC
IF GetSrc% THEN
   InputSrc% = INP(BasePort% + 5) AND 2 + INP(BasePort% + 5) AND 4
ELSE
   OUT BasePort% + 5, InputSrc% AND 7
END IF
END SUB

SUB intro
SCREEN 12
CLS
SLEEP 1
DEF SEG = &HA000
BLOAD "carlin1.dat", 0
wavplay "intro.wav", 11000

DO: LOOP UNTIL DMADONE

SCREEN 13
SLEEP 1
DEF SEG = &HA000
BLOAD "carlin2.dat", 0
wavplay "opnsng.wav", 7000
END SUB

SUB LineVolume (right%, left%, Getvol%)
OUT BasePort% + 4, &H2E
IF Getvol% THEN
   left% = INP(BasePort% + 5) \ 16
   right% = INP(BasePort% + 5) AND &HF
   EXIT SUB
ELSE
   OUT BasePort% + 5, (right% + left% * 16) AND &HFF
END IF
END SUB

SUB MasterVolume (right%, left%, Getvol%)
OUT BasePort% + 4, &H22
'PRINT BasePort%
IF Getvol% THEN
   left% = INP(BasePort% + 5) \ 16
   right% = INP(BasePort% + 5) AND &HF
   EXIT SUB
ELSE
   OUT BasePort% + 5, (right% + left% * 16) AND &HFF
END IF
END SUB

SUB MicVolume (Volume%, Getvol%)
OUT BasePort% + 4, &HA
IF Getvol% THEN
   Volume% = INP(BasePort% + 5) AND &HF
   EXIT SUB
ELSE
   OUT BasePort% + 5, Volume% AND &HF
END IF
END SUB

SUB pause
wavplay "pause.wav", 11000
DIM pause1(2000)
GET (109, 80)-(209, 120), pause1
LINE (109, 80)-(209, 120), 15, BF
LINE (109, 80)-(209, 120), 40, B
LINE (110, 81)-(208, 119), 41, B
bigletter "- PAUSE -", 1, 1, 12, 123, 95
DO: LOOP WHILE INKEY$ = ""
LINE (109, 80)-(209, 120), 0, BF
PUT (109, 80), pause1

END SUB

SUB pyrmd (aa, bb, which)
'=====================================
'which = :
' 1 = light green
' 2 = peach
' 3 = redish purple
' 4 = purple pink
' 5 = blackish grey
' 6 = grayish white
' 7 = blueish red
'=====================================



IF which = 1 THEN
 cr1 = 70     'light green
END IF
IF which = 2 THEN
 cr1 = 88    'peach
END IF
IF which = 3 THEN
 cr1 = 36    'redish purple
END IF
IF which = 4 THEN
 cr1 = 56     'purple pink
END IF
IF which = 5 THEN
 cr1 = 18    ' grey
END IF
IF which = 6 THEN
 cr1 = 24    'white
END IF
IF which = 7 THEN
 cr1 = 32
END IF
cr2 = cr1 + 1
cr3 = cr2 + 1
cr4 = cr3 + 1
cr5 = cr4 + 1
cr6 = cr5 + 1
cr7 = cr6 + 1
cr8 = cr7 + 1


LINE (aa, bb)-(aa + 20, bb + 15), cr1, BF
LINE (aa + 1, bb + 1)-(aa + 19, bb + 14), cr2, BF
LINE (aa + 2, bb + 2)-(aa + 18, bb + 13), cr3, BF
LINE (aa + 3, bb + 3)-(aa + 17, bb + 12), cr4, BF
LINE (aa + 4, bb + 4)-(aa + 16, bb + 11), cr5, BF
LINE (aa + 5, bb + 5)-(aa + 15, bb + 10), cr6, BF
LINE (aa + 6, bb + 6)-(aa + 14, bb + 9), cr7, BF
LINE (aa + 7, bb + 7)-(aa + 13, bb + 8), cr8, BF
END SUB

FUNCTION ReadDAC%
' Reads a byte from the DAC.
WriteDSP &H20
ReadDAC% = ReadDSP%

END FUNCTION

FUNCTION ReadDSP%
' Reads a byte from the DSP
DO
LOOP UNTIL INP(BasePort% + 14) AND &H80
ReadDSP% = INP(BasePort% + 10)
END FUNCTION

FUNCTION ResetDSP%
' Resets the DSP
OUT BasePort% + 6, 1
FOR Count% = 1 TO 4
   junk% = INP(BasePort% + 6)
NEXT
OUT BasePort% + 6, 0
IF INP(BasePort% + 14) AND &H80 = &H80 AND INP(BasePort% + 10) = &HAA THEN
   ResetDSP% = -1
ELSE
   ResetDSP% = 0
END IF
END FUNCTION

SUB SetStereo (OnOff%)
OUT BasePort% + 4, &HE
IF OnOff% THEN OUT BasePort% + 5, 2 ELSE OUT BasePort% + 5, 0
END SUB

SUB SpeakerState (OnOff%)
' Turns speaker on or off.
IF OnOff% THEN WriteDSP &HD1 ELSE WriteDSP &HD3
END SUB

FUNCTION SpeakerStatus%
OUT BasePort% + 4, &HD8
IF INP(BasePort% + 5) = &HFF THEN SpeakerStatus% = -1 ELSE SpeakerStatus% = 0
END FUNCTION

SUB VocVolume (right%, left%, Getvol%)
OUT BasePort% + 4, &H4
IF Getvol% THEN
   left% = INP(BasePort% + 5) \ 16
   right% = INP(BasePort% + 5) AND &HF
   EXIT SUB
ELSE
   OUT BasePort% + 5, (right% + left% * 16) AND &HFF
END IF
END SUB

SUB wavplay (file$, Frec&)
OPEN file$ FOR BINARY AS #1

DO
GET #1, 44 + (32767 * CurrentPlay!), WavBuffer(1)'Get 32k from file (skip header on WAV)

CurrentPlay! = CurrentPlay! + 1

Length& = LOF(1) - 44
IF Length& > 32767 THEN Length& = 32767 'Adjust length if needed to 32k
DMAPlay VARSEG(WavBuffer(1)), VARPTR(WavBuffer(1)), Length&, Frec&

LOOP UNTIL EOF(1)
CLOSE 1
END SUB

SUB WriteDAC (byte%)
' Writes a byte to the DAC.
WriteDSP &H10
WriteDSP byte%
END SUB

SUB WriteDSP (byte%)
' Writes a byte to the DSP
DO
LOOP WHILE INP(BasePort% + 12) AND &H80
OUT BasePort% + 12, byte%
END SUB

